//
//  Access.cs  demonstrates deriving a new class from a base class in
//              another assembly. Also demonstrates how a derived class
//              may provide a public property to expose a protected member
//              of a base class.
//
//              Compile this program with the following command line:
//                  C:>csc Access.cs
//
namespace nsAccess
{
    using System;
    class clsMain
    {
        static public void Main ()
        {
        }
    }
//
// Declare a base class with a private field, then declare
// a protected property to access the field
    public class clsBase
    {
        private int m_Private;
        protected int Private
        {
            get {return (m_Private);}
            set {m_Private = value;}
        }
        public void ShowField ()
        {
            Console.WriteLine ("The value of private field m_Private is " + m_Private);
        }
    }
}
