using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

namespace Editor
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuEdit;
		private System.Windows.Forms.MenuItem mnuView;
		private System.Windows.Forms.MenuItem mnuFileOpen;
		private System.Windows.Forms.MenuItem mnuFileSave;
		private System.Windows.Forms.MenuItem mnuFileSaveAs;
		private System.Windows.Forms.MenuItem mnuFileNew;
		private System.Windows.Forms.MenuItem mnuFileExit;
		private System.Windows.Forms.MenuItem mnuEditCut;
		private System.Windows.Forms.MenuItem mnuEditCopy;
		private System.Windows.Forms.MenuItem mnuEditPaste;
		private System.Windows.Forms.MenuItem mnuViewStatusBar;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.MenuItem mnuViewToolbar;
		private System.Windows.Forms.ToolBarButton tbFileNew;
		private System.Windows.Forms.ToolBarButton tbFileOpen;
		private System.Windows.Forms.ToolBarButton tbFileSave;
		private System.Windows.Forms.ToolBarButton tbAbout;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem cmnuFileOpen;
		private System.Windows.Forms.MenuItem cmnuFileSave;
		private System.Windows.Forms.MenuItem cmnuEditCut;
		private System.Windows.Forms.MenuItem cmnuEditCopy;
		private System.Windows.Forms.MenuItem cmnuEditPaste;
		private System.Windows.Forms.MenuItem dmnuFileNew;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.ColorDialog colorDialog1;
		private System.Windows.Forms.MenuItem mnuFormatSetTextColor;
		private System.Windows.Forms.MenuItem mniFormatSetBackgroundColor;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.tbFileNew = new System.Windows.Forms.ToolBarButton();
			this.mnuFileExit = new System.Windows.Forms.MenuItem();
			this.mnuEditCopy = new System.Windows.Forms.MenuItem();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.mnuFormatSetTextColor = new System.Windows.Forms.MenuItem();
			this.mnuFileNew = new System.Windows.Forms.MenuItem();
			this.mnuViewStatusBar = new System.Windows.Forms.MenuItem();
			this.cmnuEditCut = new System.Windows.Forms.MenuItem();
			this.mnuViewToolbar = new System.Windows.Forms.MenuItem();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.mnuEdit = new System.Windows.Forms.MenuItem();
			this.mnuEditCut = new System.Windows.Forms.MenuItem();
			this.mnuEditPaste = new System.Windows.Forms.MenuItem();
			this.cmnuFileOpen = new System.Windows.Forms.MenuItem();
			this.tbFileOpen = new System.Windows.Forms.ToolBarButton();
			this.dmnuFileNew = new System.Windows.Forms.MenuItem();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbFileSave = new System.Windows.Forms.ToolBarButton();
			this.tbAbout = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.cmnuFileSave = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.cmnuEditCopy = new System.Windows.Forms.MenuItem();
			this.cmnuEditPaste = new System.Windows.Forms.MenuItem();
			this.mnuFileOpen = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuFileSave = new System.Windows.Forms.MenuItem();
			this.mnuFileSaveAs = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuView = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.mniFormatSetBackgroundColor = new System.Windows.Forms.MenuItem();
			this.colorDialog1 = new System.Windows.Forms.ColorDialog();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// tbFileNew
			// 
			this.tbFileNew.ImageIndex = 0;
			this.tbFileNew.Text = "New";
			this.tbFileNew.ToolTipText = "Create a new text file";
			// 
			// mnuFileExit
			// 
			this.mnuFileExit.Index = 5;
			this.mnuFileExit.Text = "Exit";
			this.mnuFileExit.Click += new System.EventHandler(this.mnuFileExit_Click);
			// 
			// mnuEditCopy
			// 
			this.mnuEditCopy.Index = 1;
			this.mnuEditCopy.Text = "Copy";
			this.mnuEditCopy.Click += new System.EventHandler(this.mnuEditCopy_Click);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.FileName = "doc1";
			// 
			// mnuFormatSetTextColor
			// 
			this.mnuFormatSetTextColor.Index = 0;
			this.mnuFormatSetTextColor.Text = "Set Text Color";
			this.mnuFormatSetTextColor.Click += new System.EventHandler(this.mnuFormatSetTextColor_Click);
			// 
			// mnuFileNew
			// 
			this.mnuFileNew.Index = 0;
			this.mnuFileNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.mnuFileNew.Text = "New";
			this.mnuFileNew.Click += new System.EventHandler(this.mnuFileNew_Click);
			// 
			// mnuViewStatusBar
			// 
			this.mnuViewStatusBar.Checked = true;
			this.mnuViewStatusBar.Index = 0;
			this.mnuViewStatusBar.Text = "Status Bar";
			this.mnuViewStatusBar.Click += new System.EventHandler(this.mnuViewStatusBar_Click);
			// 
			// cmnuEditCut
			// 
			this.cmnuEditCut.Index = 4;
			this.cmnuEditCut.Text = "Cut";
			this.cmnuEditCut.Click += new System.EventHandler(this.mnuEditCut_Click);
			// 
			// mnuViewToolbar
			// 
			this.mnuViewToolbar.Checked = true;
			this.mnuViewToolbar.Index = 1;
			this.mnuViewToolbar.Text = "Toolbar";
			this.mnuViewToolbar.Click += new System.EventHandler(this.mnuViewToolbar_Click);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 253);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(520, 20);
			this.statusBar1.TabIndex = 2;
			// 
			// mnuEdit
			// 
			this.mnuEdit.Index = 1;
			this.mnuEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuEditCut,
																					this.mnuEditCopy,
																					this.mnuEditPaste});
			this.mnuEdit.Text = "&Edit";
			// 
			// mnuEditCut
			// 
			this.mnuEditCut.Index = 0;
			this.mnuEditCut.Text = "Cut";
			this.mnuEditCut.Click += new System.EventHandler(this.mnuEditCut_Click);
			// 
			// mnuEditPaste
			// 
			this.mnuEditPaste.Index = 2;
			this.mnuEditPaste.Text = "Paste";
			this.mnuEditPaste.Click += new System.EventHandler(this.mnuEditPaste_Click);
			// 
			// cmnuFileOpen
			// 
			this.cmnuFileOpen.Index = 1;
			this.cmnuFileOpen.Text = "Open";
			this.cmnuFileOpen.Click += new System.EventHandler(this.mnuFileOpen_Click);
			// 
			// tbFileOpen
			// 
			this.tbFileOpen.ImageIndex = 1;
			this.tbFileOpen.Text = "Open";
			this.tbFileOpen.ToolTipText = "Open an existing text file";
			// 
			// dmnuFileNew
			// 
			this.dmnuFileNew.Index = 0;
			this.dmnuFileNew.Text = "New";
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbFileNew,
																						this.tbFileOpen,
																						this.tbFileSave,
																						this.tbAbout});
			this.toolBar1.ButtonSize = new System.Drawing.Size(36, 36);
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(520, 39);
			this.toolBar1.TabIndex = 2;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbFileSave
			// 
			this.tbFileSave.ImageIndex = 2;
			this.tbFileSave.Text = "Save";
			this.tbFileSave.ToolTipText = "Save the contents in a text file";
			// 
			// tbAbout
			// 
			this.tbAbout.ImageIndex = 3;
			this.tbAbout.Text = "About";
			this.tbAbout.ToolTipText = "Information on the text editor";
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// textBox1
			// 
			this.textBox1.ContextMenu = this.contextMenu1;
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBox1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(0, 39);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(520, 214);
			this.textBox1.TabIndex = 3;
			this.textBox1.Text = "";
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.dmnuFileNew,
																						 this.cmnuFileOpen,
																						 this.cmnuFileSave,
																						 this.menuItem5,
																						 this.cmnuEditCut,
																						 this.cmnuEditCopy,
																						 this.cmnuEditPaste});
			// 
			// cmnuFileSave
			// 
			this.cmnuFileSave.Index = 2;
			this.cmnuFileSave.Text = "Save";
			this.cmnuFileSave.Click += new System.EventHandler(this.mnuFileSave_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Text = "-";
			// 
			// cmnuEditCopy
			// 
			this.cmnuEditCopy.Index = 5;
			this.cmnuEditCopy.Text = "Copy";
			this.cmnuEditCopy.Click += new System.EventHandler(this.mnuEditCopy_Click);
			// 
			// cmnuEditPaste
			// 
			this.cmnuEditPaste.Index = 6;
			this.cmnuEditPaste.Text = "Paste";
			this.cmnuEditPaste.Click += new System.EventHandler(this.mnuEditPaste_Click);
			// 
			// mnuFileOpen
			// 
			this.mnuFileOpen.Index = 1;
			this.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.mnuFileOpen.Text = "Open";
			this.mnuFileOpen.Click += new System.EventHandler(this.mnuFileOpen_Click);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile,
																					  this.mnuEdit,
																					  this.mnuView,
																					  this.menuItem2});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFileNew,
																					this.mnuFileOpen,
																					this.mnuFileSave,
																					this.mnuFileSaveAs,
																					this.menuItem1,
																					this.mnuFileExit});
			this.mnuFile.Text = "&File";
			// 
			// mnuFileSave
			// 
			this.mnuFileSave.Index = 2;
			this.mnuFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.mnuFileSave.Text = "Save";
			this.mnuFileSave.Click += new System.EventHandler(this.mnuFileSave_Click);
			// 
			// mnuFileSaveAs
			// 
			this.mnuFileSaveAs.Index = 3;
			this.mnuFileSaveAs.Text = "Save As";
			this.mnuFileSaveAs.Click += new System.EventHandler(this.mnuFileSaveAs_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 4;
			this.menuItem1.Text = "-";
			// 
			// mnuView
			// 
			this.mnuView.Index = 2;
			this.mnuView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuViewStatusBar,
																					this.mnuViewToolbar});
			this.mnuView.RadioCheck = true;
			this.mnuView.Text = "&View";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 3;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFormatSetTextColor,
																					  this.mniFormatSetBackgroundColor});
			this.menuItem2.Text = "Format";
			// 
			// mniFormatSetBackgroundColor
			// 
			this.mniFormatSetBackgroundColor.Index = 1;
			this.mniFormatSetBackgroundColor.Text = "Set Background Color";
			this.mniFormatSetBackgroundColor.Click += new System.EventHandler(this.mnuFormatSetBackgroundColor_Click);
			// 
			// colorDialog1
			// 
			this.colorDialog1.FullOpen = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.textBox1,
																		  this.toolBar1,
																		  this.statusBar1});
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Editor";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_OnClosing);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		string m_strFileName = "";
		bool m_bReadOnly = false;

		private void mnuFileNew_Click(object sender, System.EventArgs e)
		{
//
// If the text has changed since the last save, ask first
// before clearing the text
			if (textBox1.Modified == true)
			{
				string str;
				if (m_strFileName.Length > 0)
				{
					str = m_strFileName;
				}
				else
				{
					str = "The text in the edit control ";
				}
				str += " has changed. Do you want to save it?";
				if (MessageBox.Show(str, "TextChanged",
					MessageBoxButtons.YesNo) == DialogResult.Yes)
				{
					mnuFileSave_Click (sender, e);
				}
			}
//
// Erase any text in the text box.
			textBox1.Clear ();
// and set the modified flag to false
			textBox1.Modified = false;
// Empty the file name
			m_strFileName = "";
			statusBar1.Text = "";
		}

		private void mnuFileOpen_Click(object sender, System.EventArgs e)
		{
// Intialize with the last file name used.
			openFileDialog1.FileName = m_strFileName;
// Set the filter for text files
			openFileDialog1.Filter = "Text files (*.txt)|*.txt|C# files (*.cs)|*.cs";
// Show the Read Only check box on the dialog box
			openFileDialog1.ShowReadOnly = true;
// The default extension is for text files
			openFileDialog1.DefaultExt = ".txt";
			if (openFileDialog1.ShowDialog () ==
				DialogResult.Cancel)
			{
				return;
			}
			this.m_strFileName = openFileDialog1.FileName;
			FileStream strm;
			try
			{
				strm = new FileStream (m_strFileName,
					FileMode.Open,
					FileAccess.Read);
				StreamReader reader = new StreamReader(strm);
				textBox1.Text = reader.ReadToEnd ();
// Save the state of the read only box
				m_bReadOnly = openFileDialog1.ReadOnlyChecked;
				strm.Close ();
// Set the selection so the caret is at the top of the file
				textBox1.SelectionStart = 0;
				textBox1.SelectionLength = 0;
// Adding text to the text box sets its Modified property to
// true. The file has not actually been modified, so reset
// the Modified property.
				textBox1.Modified = false;
				statusBar1.Text = m_strFileName;
			}
// Catch the exception when the file cannot be found.
			catch (FileNotFoundException)
			{
				MessageBox.Show ("Cannot open file", "Warning");
			}
		}

		private void mnuFileSave_Click(object sender, System.EventArgs e)
		{
			if (m_bReadOnly)
			{
				MessageBox.Show ("File is open as Read-Only",
					"Warning");
				return;
			}
			if (m_strFileName.Length == 0)
			{
				mnuFileSaveAs_Click (sender, e);
				return;
			}
			if (textBox1.Modified == false)
			{
				return;
			}
			if (m_strFileName.Length == 0)
			{
				return;
			}
			FileStream strm;
			try
			{
				strm = new FileStream (m_strFileName,
					FileMode.Open,
					FileAccess.Write);
				StreamWriter writer = new StreamWriter(strm);
				writer.Write (textBox1.Text);
				writer.Flush ();
// Chop off any straggler text in the file.
				strm.SetLength (textBox1.Text.Length);
				strm.Close ();
				textBox1.Modified = false;
			}
			catch (FileNotFoundException)
			{
				MessageBox.Show ("Cannot open file", "Warning");
			}
			catch (NotSupportedException)
			{
				MessageBox.Show ("Cannot write to file", "Warning");
			}
			catch (UnauthorizedAccessException)
			{
				MessageBox.Show ("Not authorized to write to file",
					"Warning");
			}
		}

		private void mnuFileSaveAs_Click(object sender, System.EventArgs e)
		{
			if (m_strFileName.Length > 0)
			{
				saveFileDialog1.FileName = m_strFileName;
			}
			if (saveFileDialog1.ShowDialog () ==
				DialogResult.Cancel)
			{
				return;
			}
			if (saveFileDialog1.FileName.Length == 0)
			{
				return;
			}
			string fn = saveFileDialog1.FileName;
			FileStream strm;
			try
			{
				strm = new FileStream (fn, FileMode.OpenOrCreate,
					FileAccess.Write);
				StreamWriter writer = new StreamWriter(strm);
				writer.Write (textBox1.Text);
				writer.Flush ();
				// Chop off any straggler text in the file.
				strm.SetLength (textBox1.Text.Length);
				strm.Close ();
				textBox1.Modified = false;
				m_strFileName = fn;
				statusBar1.Text = m_strFileName;
			}
			catch (FileNotFoundException)
			{
				MessageBox.Show ("Cannot open file", "Warning");
			}
			catch (NotSupportedException)
			{
				MessageBox.Show ("Cannot write to file", "Warning");
			}
			catch (UnauthorizedAccessException)
			{
				MessageBox.Show ("Not authorized to write to file",
					"Warning");
			}
		}

		private void mnuFileExit_Click(object sender, System.EventArgs e)
		{
			Close ();
		}

		private void mnuEditCut_Click(object sender, System.EventArgs e)
		{
			textBox1.Cut();
		}

		private void mnuEditCopy_Click(object sender, System.EventArgs e)
		{
			textBox1.Copy();
		}

		private void mnuEditPaste_Click(object sender, System.EventArgs e)
		{
			textBox1.Paste();
		}

		private void mnuViewStatusBar_Click(object sender, System.EventArgs e)
		{
			statusBar1.Visible ^= true;
			mnuViewStatusBar.Checked = statusBar1.Visible;
		}

		private void mnuViewToolbar_Click(object sender, System.EventArgs e)
		{
			toolBar1.Visible ^= true;
			mnuViewToolbar.Checked = toolBar1.Visible;
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch (e.Button.ImageIndex)
			{
				case 0:
					mnuFileNew_Click(sender, (System.EventArgs) e);
					break;
				case 1:
					mnuFileOpen_Click(sender, (System.EventArgs) e);
					break;
				case 2:
					mnuFileSave_Click(sender, (System.EventArgs) e);
					break;
			}
		}

// Set up some permanent storage for the custom colors

		int [] clrCustom = new int [16]
					   {
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff
					   };
		private void mnuFormatSetTextColor_Click(object sender, System.EventArgs e)
		{
			ColorDialog cd = new ColorDialog ();
			// Setting FullOpen to true will display the custom color portion
			// when the dialog box first opens.
			cd.FullOpen = false;
			// Setting the Color property will select the color in the dialog
			cd.Color = textBox1.ForeColor;
			// Setting AnyColor to true will cause the dialog box to display
			// all available colors
			cd.AnyColor = false;
			// Setting AllowFullOpen to false will prevent the user from
			// displaying the custom color section. This override FullOpen.
			cd.AllowFullOpen = true;
			// Setting CustomColors to an array of int will initialize the
			// 16 custom color boxes.
			cd.CustomColors = clrCustom;
			// Setting ShowHelp to true will display a help button. You are
			// responsible for writing the help file, however.
			cd.ShowHelp = false;
			// Setting SolidColorOnly to false will restrict the selection to
			// a solidcolor. This has meaning only when the palette contains less than
			// a full set.
			cd.SolidColorOnly = false;
			if (cd.ShowDialog () == DialogResult.Cancel)
				return;
			textBox1.ForeColor = cd.Color;
			clrCustom = cd.CustomColors;
		}

		private void mnuFormatSetBackgroundColor_Click(object sender, System.EventArgs e)
		{
			// Intialize the color for the dialog box.
			colorDialog1.Color = textBox1.BackColor;
			// Set the custom colors to the member array.
			colorDialog1.CustomColors = clrCustom;
			// Show the colors.
			if (colorDialog1.ShowDialog () == DialogResult.Cancel)
				return;
			// Save any custom colors the user selected.
			clrCustom = colorDialog1.CustomColors;
			// Set the text box background color.
			textBox1.BackColor = colorDialog1.Color;
		}

		private void Form1_OnClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (textBox1.Modified == true)
			{
				DialogResult result;
				result = MessageBox.Show ("The file contents have changed. Do you want to save it first?",
					"File Modified", MessageBoxButtons.YesNoCancel);
				switch (result)
				{
					case DialogResult.Yes:
						mnuFileSave_Click (sender, e);
						break;
					case DialogResult.No:
						break;
					case DialogResult.Cancel:
						e.Cancel = true;
						return;
				}
			}
			Application.Exit ();
		}
	}
}
