// DebugTst.cs -- A simple demonstration of the Debug class.
//
//                Compile this program with the following command line:
//                    C:>csc /debug:full /d:DEBUG DebugTst.cs
using System;
using System.Diagnostics;
using System.IO;

namespace nsDebugTest
{
    class clsMain
    {
        static void Main()
        {
//            Debug.Listeners.Clear();
//            Debug.Listeners.Add (new TextWriterTraceListener(Console.Out));
//            Debug.AutoFlush = true;
            Debug.WriteLine ("Debug is on");
            clsTest test = new clsTest(42);
            test.ShowValue();
        }
    }
    class clsTest
    {
        public clsTest (int num)
        {
            m_Num = num;
        }
        int m_Num;

        public void ShowValue()
        {
            try
            {
                DoSomething ();
            }
            catch (Exception e)
            {
                Console.WriteLine (e.StackTrace);
            }
            if (m_Num < 50)
            {
                Debug.WriteLine (m_Num + " is less than 50");
            }
        }
        void DoSomething ()
        {
            Debug.WriteLine (Environment.StackTrace);
        }
    }
}

