namespace nsType
{
    using System;
    class clsMain
    {
        public static void Main ()
        {
            int [] arr1 = new int[] {1, 4, 2, 8, 5, 7};
            int [] arr2 = new int[arr1.Length];
            MemCpy (arr2, arr1, arr1.Length);
            arr1[0] = 142857;
            for (int x = 0; x < arr1.Length; ++x)
            {
                Console.Write ("arr1[{0}] = {1}\t", x, arr1[x]);
                Console.Write ("arr2[{0}] = {1}\n", x, arr2[x]);
            }
        }

        static unsafe public void MemCpy (int [] dst, int [] src, int size)
        {
            if ((size > dst.Length) || (size > src.Length))
            {
                ArgumentException e = new ArgumentException("The size argument is too large for one of the array arguments");
                throw (e);
            }
            fixed (int *Src = src, Dst = dst)
            {
                int* pSrc = Src;
                int* pDst = Dst;
                for (int n = 0; n < size; ++n)
                {
                    *pDst++ = *pSrc++;
                }
            }
        }
    }
}
