//
//  OvrFlow1.cs -- Demonstates using checked keyword to detect an overflow.
//
//          Compile this program with the following command line:
//              C:>csc OvrFlow1.cs
//
namespace nsOverflow
{
    using System;
    class clsMain
    {
        static public void Main ()
        {
            int large = 2147483647;
            int larger = large;
            try
            {
                larger = checked (++larger);
            }
            catch (OverflowException e)
            {
                Console.WriteLine ("The operation caused an overflow");
                Console.WriteLine (e.Message);
            }
            Console.WriteLine ("large = " + large);
            Console.WriteLine ("larger = " + larger);
        }
    }
}
