//
// Overload.cs -- Provides a simple example of function overloading
//
//                Compile this program with the following command line:
//                    C:>csc Overload.cs
//
namespace nsOverload
{
    using System;
    class clsMain
    {
        static public void Main ()
        {
            int iVal = 16;
            long lVal = 24;
            Console.WriteLine ("The square of {0} is {1}\r\n",
                               iVal, Square(iVal));
            Console.WriteLine ("The square of {0} is {1}",
                               lVal, Square(lVal));
        }
        static int Square (int var)
        {
            Console.WriteLine ("int Square (int var) method called");
            return (var * var);
        }
        static long Square (long var)
        {
            Console.WriteLine ("long Square (long var) method called");
            return (var * var);
        }
    }
}
