using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Drawing.Printing;
using System.Text;

namespace Editor
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuEdit;
		private System.Windows.Forms.MenuItem mnuView;
		private System.Windows.Forms.MenuItem mnuFileOpen;
		private System.Windows.Forms.MenuItem mnuFileSave;
		private System.Windows.Forms.MenuItem mnuFileSaveAs;
		private System.Windows.Forms.MenuItem mnuFileNew;
		private System.Windows.Forms.MenuItem mnuFileExit;
		private System.Windows.Forms.MenuItem mnuEditCut;
		private System.Windows.Forms.MenuItem mnuEditCopy;
		private System.Windows.Forms.MenuItem mnuEditPaste;
		private System.Windows.Forms.MenuItem mnuViewStatusBar;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.MenuItem mnuViewToolbar;
		private System.Windows.Forms.ToolBarButton tbFileNew;
		private System.Windows.Forms.ToolBarButton tbFileOpen;
		private System.Windows.Forms.ToolBarButton tbFileSave;
		private System.Windows.Forms.ToolBarButton tbAbout;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem cmnuFileOpen;
		private System.Windows.Forms.MenuItem cmnuFileSave;
		private System.Windows.Forms.MenuItem cmnuEditCut;
		private System.Windows.Forms.MenuItem cmnuEditCopy;
		private System.Windows.Forms.MenuItem cmnuEditPaste;
		private System.Windows.Forms.MenuItem dmnuFileNew;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.ColorDialog colorDialog1;
		private System.Windows.Forms.FontDialog fontDialog1;
		private System.Windows.Forms.MenuItem mnuFormatSetFont;
		private System.Windows.Forms.MenuItem mnuFormatSetTextColor;
		private System.Windows.Forms.MenuItem mnuFormatSetBackgroundColor;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem mnuFilePrint;
		private System.Windows.Forms.MenuItem mnuFilePrintPreview;
		private System.Windows.Forms.MenuItem mnuFilePageSetup;
		private System.Windows.Forms.PrintDialog printDialog1;
		private System.Windows.Forms.PageSetupDialog pageSetupDialog1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.mnuFormatSetTextColor = new System.Windows.Forms.MenuItem();
			this.mnuFilePrint = new System.Windows.Forms.MenuItem();
			this.mnuFilePageSetup = new System.Windows.Forms.MenuItem();
			this.tbAbout = new System.Windows.Forms.ToolBarButton();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuFileNew = new System.Windows.Forms.MenuItem();
			this.mnuFileOpen = new System.Windows.Forms.MenuItem();
			this.mnuFileSave = new System.Windows.Forms.MenuItem();
			this.mnuFileSaveAs = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.mnuFilePrintPreview = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.mnuFileExit = new System.Windows.Forms.MenuItem();
			this.mnuEdit = new System.Windows.Forms.MenuItem();
			this.mnuEditCut = new System.Windows.Forms.MenuItem();
			this.mnuEditCopy = new System.Windows.Forms.MenuItem();
			this.mnuEditPaste = new System.Windows.Forms.MenuItem();
			this.mnuView = new System.Windows.Forms.MenuItem();
			this.mnuViewStatusBar = new System.Windows.Forms.MenuItem();
			this.mnuViewToolbar = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.mnuFormatSetBackgroundColor = new System.Windows.Forms.MenuItem();
			this.mnuFormatSetFont = new System.Windows.Forms.MenuItem();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.toolBar1 = new System.Windows.Forms.ToolBar();
			this.tbFileNew = new System.Windows.Forms.ToolBarButton();
			this.tbFileOpen = new System.Windows.Forms.ToolBarButton();
			this.tbFileSave = new System.Windows.Forms.ToolBarButton();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.dmnuFileNew = new System.Windows.Forms.MenuItem();
			this.cmnuEditCut = new System.Windows.Forms.MenuItem();
			this.cmnuFileSave = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.pageSetupDialog1 = new System.Windows.Forms.PageSetupDialog();
			this.cmnuEditCopy = new System.Windows.Forms.MenuItem();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.cmnuFileOpen = new System.Windows.Forms.MenuItem();
			this.cmnuEditPaste = new System.Windows.Forms.MenuItem();
			this.fontDialog1 = new System.Windows.Forms.FontDialog();
			this.colorDialog1 = new System.Windows.Forms.ColorDialog();
			this.printDialog1 = new System.Windows.Forms.PrintDialog();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.SuspendLayout();
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.FileName = "doc1";
			// 
			// mnuFormatSetTextColor
			// 
			this.mnuFormatSetTextColor.Index = 0;
			this.mnuFormatSetTextColor.Text = "Set Text Color";
			this.mnuFormatSetTextColor.Click += new System.EventHandler(this.mnuFormatSetTextColor_Click);
			// 
			// mnuFilePrint
			// 
			this.mnuFilePrint.Index = 5;
			this.mnuFilePrint.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
			this.mnuFilePrint.Text = "Print";
			this.mnuFilePrint.Click += new System.EventHandler(this.mnuFilePrint_Click);
			// 
			// mnuFilePageSetup
			// 
			this.mnuFilePageSetup.Index = 7;
			this.mnuFilePageSetup.Text = "Page Setup";
			this.mnuFilePageSetup.Click += new System.EventHandler(this.mnuFilePageSetup_Click);
			// 
			// tbAbout
			// 
			this.tbAbout.ImageIndex = 3;
			this.tbAbout.Text = "About";
			this.tbAbout.ToolTipText = "Information on the text editor";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile,
																					  this.mnuEdit,
																					  this.mnuView,
																					  this.menuItem2});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFileNew,
																					this.mnuFileOpen,
																					this.mnuFileSave,
																					this.mnuFileSaveAs,
																					this.menuItem6,
																					this.mnuFilePrint,
																					this.mnuFilePrintPreview,
																					this.mnuFilePageSetup,
																					this.menuItem7,
																					this.mnuFileExit});
			this.mnuFile.Text = "&File";
			// 
			// mnuFileNew
			// 
			this.mnuFileNew.Index = 0;
			this.mnuFileNew.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.mnuFileNew.Text = "New";
			this.mnuFileNew.Click += new System.EventHandler(this.mnuFileNew_Click);
			// 
			// mnuFileOpen
			// 
			this.mnuFileOpen.Index = 1;
			this.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.mnuFileOpen.Text = "Open";
			this.mnuFileOpen.Click += new System.EventHandler(this.mnuFileOpen_Click);
			// 
			// mnuFileSave
			// 
			this.mnuFileSave.Index = 2;
			this.mnuFileSave.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.mnuFileSave.Text = "Save";
			this.mnuFileSave.Click += new System.EventHandler(this.mnuFileSave_Click);
			// 
			// mnuFileSaveAs
			// 
			this.mnuFileSaveAs.Index = 3;
			this.mnuFileSaveAs.Text = "Save As";
			this.mnuFileSaveAs.Click += new System.EventHandler(this.mnuFileSaveAs_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 4;
			this.menuItem6.Text = "-";
			// 
			// mnuFilePrintPreview
			// 
			this.mnuFilePrintPreview.Index = 6;
			this.mnuFilePrintPreview.Text = "Print Preview";
			this.mnuFilePrintPreview.Click += new System.EventHandler(this.mnuFilePrintPreview_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 8;
			this.menuItem7.Text = "-";
			// 
			// mnuFileExit
			// 
			this.mnuFileExit.Index = 9;
			this.mnuFileExit.Text = "Exit";
			this.mnuFileExit.Click += new System.EventHandler(this.mnuFileExit_Click);
			// 
			// mnuEdit
			// 
			this.mnuEdit.Index = 1;
			this.mnuEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuEditCut,
																					this.mnuEditCopy,
																					this.mnuEditPaste});
			this.mnuEdit.Text = "&Edit";
			// 
			// mnuEditCut
			// 
			this.mnuEditCut.Index = 0;
			this.mnuEditCut.Text = "Cut";
			this.mnuEditCut.Click += new System.EventHandler(this.mnuEditCut_Click);
			// 
			// mnuEditCopy
			// 
			this.mnuEditCopy.Index = 1;
			this.mnuEditCopy.Text = "Copy";
			this.mnuEditCopy.Click += new System.EventHandler(this.mnuEditCopy_Click);
			// 
			// mnuEditPaste
			// 
			this.mnuEditPaste.Index = 2;
			this.mnuEditPaste.Text = "Paste";
			this.mnuEditPaste.Click += new System.EventHandler(this.mnuEditPaste_Click);
			// 
			// mnuView
			// 
			this.mnuView.Index = 2;
			this.mnuView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuViewStatusBar,
																					this.mnuViewToolbar});
			this.mnuView.RadioCheck = true;
			this.mnuView.Text = "&View";
			// 
			// mnuViewStatusBar
			// 
			this.mnuViewStatusBar.Checked = true;
			this.mnuViewStatusBar.Index = 0;
			this.mnuViewStatusBar.Text = "Status Bar";
			this.mnuViewStatusBar.Click += new System.EventHandler(this.mnuViewStatusBar_Click);
			// 
			// mnuViewToolbar
			// 
			this.mnuViewToolbar.Checked = true;
			this.mnuViewToolbar.Index = 1;
			this.mnuViewToolbar.Text = "Toolbar";
			this.mnuViewToolbar.Click += new System.EventHandler(this.mnuViewToolbar_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 3;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFormatSetTextColor,
																					  this.mnuFormatSetBackgroundColor,
																					  this.mnuFormatSetFont});
			this.menuItem2.Text = "Format";
			// 
			// mnuFormatSetBackgroundColor
			// 
			this.mnuFormatSetBackgroundColor.Index = 1;
			this.mnuFormatSetBackgroundColor.Text = "Set Background Color";
			this.mnuFormatSetBackgroundColor.Click += new System.EventHandler(this.mnuFormatSetBackgroundColor_Click);
			// 
			// mnuFormatSetFont
			// 
			this.mnuFormatSetFont.Index = 2;
			this.mnuFormatSetFont.Text = "Set Font";
			this.mnuFormatSetFont.Click += new System.EventHandler(this.mnuFormatSetFont_Click);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.CheckFileExists = false;
			this.openFileDialog1.CheckPathExists = false;
			this.openFileDialog1.DefaultExt = "cs";
			// 
			// toolBar1
			// 
			this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																						this.tbFileNew,
																						this.tbFileOpen,
																						this.tbFileSave,
																						this.tbAbout});
			this.toolBar1.ButtonSize = new System.Drawing.Size(36, 36);
			this.toolBar1.DropDownArrows = true;
			this.toolBar1.ImageList = this.imageList1;
			this.toolBar1.Name = "toolBar1";
			this.toolBar1.ShowToolTips = true;
			this.toolBar1.Size = new System.Drawing.Size(520, 39);
			this.toolBar1.TabIndex = 2;
			this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
			// 
			// tbFileNew
			// 
			this.tbFileNew.ImageIndex = 0;
			this.tbFileNew.Text = "New";
			this.tbFileNew.ToolTipText = "Create a new text file";
			// 
			// tbFileOpen
			// 
			this.tbFileOpen.ImageIndex = 1;
			this.tbFileOpen.Text = "Open";
			this.tbFileOpen.ToolTipText = "Open an existing text file";
			// 
			// tbFileSave
			// 
			this.tbFileSave.ImageIndex = 2;
			this.tbFileSave.Text = "Save";
			this.tbFileSave.ToolTipText = "Save the contents in a text file";
			// 
			// imageList1
			// 
			this.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// dmnuFileNew
			// 
			this.dmnuFileNew.Index = 0;
			this.dmnuFileNew.Text = "New";
			// 
			// cmnuEditCut
			// 
			this.cmnuEditCut.Index = 4;
			this.cmnuEditCut.Text = "Cut";
			this.cmnuEditCut.Click += new System.EventHandler(this.mnuEditCut_Click);
			// 
			// cmnuFileSave
			// 
			this.cmnuFileSave.Index = 2;
			this.cmnuFileSave.Text = "Save";
			this.cmnuFileSave.Click += new System.EventHandler(this.mnuFileSave_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Text = "-";
			// 
			// cmnuEditCopy
			// 
			this.cmnuEditCopy.Index = 5;
			this.cmnuEditCopy.Text = "Copy";
			this.cmnuEditCopy.Click += new System.EventHandler(this.mnuEditCopy_Click);
			// 
			// textBox1
			// 
			this.textBox1.AcceptsReturn = true;
			this.textBox1.AcceptsTab = true;
			this.textBox1.ContextMenu = this.contextMenu1;
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBox1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(0, 39);
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox1.Size = new System.Drawing.Size(520, 214);
			this.textBox1.TabIndex = 3;
			this.textBox1.Text = "";
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.dmnuFileNew,
																						 this.cmnuFileOpen,
																						 this.cmnuFileSave,
																						 this.menuItem5,
																						 this.cmnuEditCut,
																						 this.cmnuEditCopy,
																						 this.cmnuEditPaste});
			// 
			// cmnuFileOpen
			// 
			this.cmnuFileOpen.Index = 1;
			this.cmnuFileOpen.Text = "Open";
			this.cmnuFileOpen.Click += new System.EventHandler(this.mnuFileOpen_Click);
			// 
			// cmnuEditPaste
			// 
			this.cmnuEditPaste.Index = 6;
			this.cmnuEditPaste.Text = "Paste";
			this.cmnuEditPaste.Click += new System.EventHandler(this.mnuEditPaste_Click);
			// 
			// fontDialog1
			// 
			this.fontDialog1.FontMustExist = true;
			this.fontDialog1.ScriptsOnly = true;
			this.fontDialog1.ShowApply = true;
			this.fontDialog1.ShowColor = true;
			this.fontDialog1.Apply += new System.EventHandler(this.fontDialog1_OnApply);
			// 
			// colorDialog1
			// 
			this.colorDialog1.FullOpen = true;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 253);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(520, 20);
			this.statusBar1.TabIndex = 2;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(520, 273);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.textBox1,
																		  this.toolBar1,
																		  this.statusBar1});
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Editor";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_OnClosing);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		string m_strFileName = "";
		bool m_bReadOnly = false;

		private void mnuFileNew_Click(object sender, System.EventArgs e)
		{
//
// If the text has changed since the last save, ask first
// before clearing the text
			if (textBox1.Modified == true)
			{
				string str;
				if (m_strFileName.Length > 0)
				{
					str = m_strFileName;
				}
				else
				{
					str = "The text in the edit control ";
				}
				str += " has changed. Do you want to save it?";
				if (MessageBox.Show(str, "TextChanged",
					MessageBoxButtons.YesNo) == DialogResult.Yes)
				{
					mnuFileSave_Click (sender, e);
				}
			}
//
// Erase any text in the text box.
			textBox1.Clear ();
// and set the modified flag to false
			textBox1.Modified = false;
// Empty the file name
			m_strFileName = "";
			statusBar1.Text = "";
		}

		private void mnuFileOpen_Click(object sender, System.EventArgs e)
		{
// Intialize with the last file name used.
			openFileDialog1.FileName = m_strFileName;
// Set the filter for text files
			openFileDialog1.Filter = "Text files (*.txt)|*.txt|C# files (*.cs)|*.cs";
// Show the Read Only check box on the dialog box
			openFileDialog1.ShowReadOnly = true;
// The default extension is for text files
//			openFileDialog1.DefaultExt = "txt";
			if (openFileDialog1.ShowDialog () ==
				DialogResult.Cancel)
			{
				return;
			}
			this.m_strFileName = openFileDialog1.FileName;
			FileStream strm;
			try
			{
				strm = new FileStream (m_strFileName,
					FileMode.Open,
					FileAccess.Read);
				StreamReader reader = new StreamReader(strm);
				textBox1.Text = reader.ReadToEnd ();
// Save the state of the read only box
				m_bReadOnly = openFileDialog1.ReadOnlyChecked;
				strm.Close ();
// Set the selection so the caret is at the top of the file
				textBox1.SelectionStart = 0;
				textBox1.SelectionLength = 0;
// Adding text to the text box sets its Modified property to
// true. The file has not actually been modified, so reset
// the Modified property.
				textBox1.Modified = false;
				statusBar1.Text = m_strFileName;
			}
// Catch the exception when the file cannot be found.
			catch (FileNotFoundException)
			{
				MessageBox.Show ("Cannot open file", "Warning");
			}
		}

		private void mnuFileSave_Click(object sender, System.EventArgs e)
		{
			if (m_bReadOnly)
			{
				MessageBox.Show ("File is open as Read-Only",
					"Warning");
				return;
			}
			if (m_strFileName.Length == 0)
			{
				mnuFileSaveAs_Click (sender, e);
				return;
			}
			if (textBox1.Modified == false)
			{
				return;
			}
			if (m_strFileName.Length == 0)
			{
				return;
			}
			FileStream strm;
			try
			{
				strm = new FileStream (m_strFileName,
					FileMode.Open,
					FileAccess.Write);
				StreamWriter writer = new StreamWriter(strm);
				writer.Write (textBox1.Text);
				writer.Flush ();
// Chop off any straggler text in the file.
				strm.SetLength (textBox1.Text.Length);
				strm.Close ();
				textBox1.Modified = false;
			}
			catch (FileNotFoundException)
			{
				MessageBox.Show ("Cannot open file", "Warning");
			}
			catch (NotSupportedException)
			{
				MessageBox.Show ("Cannot write to file", "Warning");
			}
			catch (UnauthorizedAccessException)
			{
				MessageBox.Show ("Not authorized to write to file",
					"Warning");
			}
		}

		private void mnuFileSaveAs_Click(object sender, System.EventArgs e)
		{
			if (m_strFileName.Length > 0)
			{
				saveFileDialog1.FileName = m_strFileName;
			}
			if (saveFileDialog1.ShowDialog () ==
				DialogResult.Cancel)
			{
				return;
			}
			if (saveFileDialog1.FileName.Length == 0)
			{
				return;
			}
			string fn = saveFileDialog1.FileName;
			FileStream strm;
			try
			{
				strm = new FileStream (fn, FileMode.OpenOrCreate,
					FileAccess.Write);
				StreamWriter writer = new StreamWriter(strm);
				writer.Write (textBox1.Text);
				writer.Flush ();
				// Chop off any straggler text in the file.
				strm.SetLength (textBox1.Text.Length);
				strm.Close ();
				textBox1.Modified = false;
				m_strFileName = fn;
				statusBar1.Text = m_strFileName;
			}
			catch (FileNotFoundException)
			{
				MessageBox.Show ("Cannot open file", "Warning");
			}
			catch (NotSupportedException)
			{
				MessageBox.Show ("Cannot write to file", "Warning");
			}
			catch (UnauthorizedAccessException)
			{
				MessageBox.Show ("Not authorized to write to file",
					"Warning");
			}
		}

		private void mnuFileExit_Click(object sender, System.EventArgs e)
		{
			Close ();
		}

		private void mnuEditCut_Click(object sender, System.EventArgs e)
		{
			textBox1.Cut();
		}

		private void mnuEditCopy_Click(object sender, System.EventArgs e)
		{
			textBox1.Copy();
		}

		private void mnuEditPaste_Click(object sender, System.EventArgs e)
		{
			textBox1.Paste();
		}

		private void mnuViewStatusBar_Click(object sender, System.EventArgs e)
		{
			statusBar1.Visible ^= true;
			mnuViewStatusBar.Checked = statusBar1.Visible;
		}

		private void Form1_OnClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (textBox1.Modified == true)
			{
				DialogResult result;
				result = MessageBox.Show ("The file contents have changed. Do you want to save it first?",
					"File Modified", MessageBoxButtons.YesNoCancel);
				switch (result)
				{
					case DialogResult.Yes:
						mnuFileSave_Click (sender, e);
						break;
					case DialogResult.No:
						break;
					case DialogResult.Cancel:
						e.Cancel = true;
						return;
				}
			}
			Application.Exit ();
		}

		private void mnuViewToolbar_Click(object sender, System.EventArgs e)
		{
			toolBar1.Visible ^= true;
			mnuViewToolbar.Checked = toolBar1.Visible;
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch (e.Button.ImageIndex)
			{
				case 0:
					mnuFileNew_Click(sender, (System.EventArgs) e);
					break;
				case 1:
					mnuFileOpen_Click(sender, (System.EventArgs) e);
					break;
				case 2:
					mnuFileSave_Click(sender, (System.EventArgs) e);
					break;
			}
		}

// Set up some permanent storage for the custom colors

		int [] clrCustom = new int [16]
					   {
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff,
						   0x00ffffff, 0x00ffffff, 0x00ffffff, 0x00ffffff
					   };
		private void mnuFormatSetTextColor_Click(object sender, System.EventArgs e)
		{
			ColorDialog cd = new ColorDialog ();
			// Setting FullOpen to true will display the custom color portion
			// when the dialog box first opens.
			cd.FullOpen = false;
			// Setting the Color property will select the color in the dialog
			cd.Color = textBox1.ForeColor;
			// Setting AnyColor to true will cause the dialog box to display
			// all available colors
			cd.AnyColor = false;
			// Setting AllowFullOpen to false will prevent the user from
			// displaying the custom color section. This override FullOpen.
			cd.AllowFullOpen = true;
			// Setting CustomColors to an array of int will initialize the
			// 16 custom color boxes.
			cd.CustomColors = clrCustom;
			// Setting ShowHelp to true will display a help button. You are
			// responsible for writing the help file, however.
			cd.ShowHelp = false;
			// Setting SolidColorOnly to false will restrict the selection to
			// a solidcolor. This has meaning only when the palette contains less than
			// a full set.
			cd.SolidColorOnly = false;
			if (cd.ShowDialog () == DialogResult.Cancel)
				return;
			textBox1.BackColor = cd.Color;
			clrCustom = cd.CustomColors;
		}

		private void mnuFormatSetBackgroundColor_Click(object sender, System.EventArgs e)
		{
// Intialize the color for the dialog box.
			colorDialog1.Color = textBox1.BackColor;
// Set the custom colors to the member array.
			colorDialog1.CustomColors = clrCustom;
			// Show the colors.
			if (colorDialog1.ShowDialog () == DialogResult.Cancel)
				return;
// Save any custom colors the user selected.
			clrCustom = colorDialog1.CustomColors;
// Set the text box background color.
			textBox1.ForeColor = colorDialog1.Color;
		}

		private void mnuFormatSetFont_Click(object sender, System.EventArgs e)
		{
// Initialize the font display to the text box font.
			fontDialog1.Font = textBox1.Font;
// Initialize the font display color to the text box text color. This
// will be an approximate value because the font dialog has a limited
// color display
			fontDialog1.Color = textBox1.ForeColor;
// Show the font dialog. Do nothing if the user presses Cancel.
			if (fontDialog1.ShowDialog () == DialogResult.Cancel)
				return;
// Call the OnApply method to set the text box values. Calling the
// same method as the Apply event means you need maintain code in
// only one location.
			fontDialog1_OnApply (sender, e);
		}

		private void fontDialog1_OnApply(object sender, System.EventArgs e)
		{
// Set the text box font.
			textBox1.Font = fontDialog1.Font;
// Set the text box text color.
			textBox1.ForeColor = fontDialog1.Color;
		}

		string m_strRemaining = "";
		StreamReader m_PrintReader;
		PrinterSettings m_PrinterSettings = new PrinterSettings ();
		PageSettings m_PageSettings = new PageSettings();

		private void mnuFilePrint_Click(object sender, System.EventArgs e)
		{
			if (textBox1.Text.Length == 0)
				return;
			byte [] bytestrm;
			try 
			{
				PrintDocument pd = new PrintDocument();
				pd.PrinterSettings = (PrinterSettings) m_PrinterSettings.Clone();
				pd.DefaultPageSettings = (PageSettings) m_PageSettings.Clone();
				printDialog1.PrinterSettings = m_PrinterSettings;
				printDialog1.Document = pd;
// If the text box contains selected text, enable the Selection box
				if (textBox1.SelectionLength > 0)
					printDialog1.AllowSelection = true;
				else
					printDialog1.AllowSelection = false;
				if (printDialog1.ShowDialog () == DialogResult.Cancel)
					return;
// If the PrintRange property of the printer settings is Selection,
// get just the selected text in the text box.
				if (printDialog1.PrinterSettings.PrintRange == PrintRange.Selection)
					bytestrm = StringToByte (textBox1.SelectedText);
// Otherwise, get all of the text in the text box.
				else
					bytestrm = StringToByte (textBox1.Text);
// Create the stream.
				MemoryStream strm = new MemoryStream (bytestrm);
				m_PrintReader = new StreamReader (strm);
				try 
				{
					m_PrinterSettings = pd.PrinterSettings;
					m_PageSettings = pd.DefaultPageSettings;
// The Document Name property is dispayed in the Windows apooler.
					if (m_strFileName == "")
						pd.DocumentName = "Untitled";
					else
						pd.DocumentName = m_strFileName;
					pd.PrintPage += new PrintPageEventHandler
						(this.OnPrintPage);
					pd.Print();
				}  
				finally 
				{
					m_PrintReader.Close();
				}
			}  
			catch(Exception e2) 
			{
				MessageBox.Show(e2.Message);
			}
			bytestrm = null;
		}

		private void mnuFilePrintPreview_Click(object sender, System.EventArgs e)
		{

		}

		private void mnuFilePageSetup_Click(object sender, System.EventArgs e)
		{
			// Clone the PageSettings so change can be aborted.
			PageSettings pageSettings = (PageSettings) m_PageSettings.Clone ();
			pageSetupDialog1.PageSettings = pageSettings;
			// To disable the printer button on the dialog, remove the following
			// two lines and the last line in this method.
			PrinterSettings printerSettings = (PrinterSettings) m_PrinterSettings.Clone ();
			pageSetupDialog1.PrinterSettings = printerSettings;
			// Set the following property to false to disable the Printer button
			//			pageSetupDialog1.AllowPrinter = false;
			// If the user presses the Cancel button, don't save any changes.
			if (pageSetupDialog1.ShowDialog () == DialogResult.Cancel)
				return;
			// Save the new settings in the instance members.
			m_PageSettings = pageSettings;
			m_PrinterSettings = printerSettings;
		}

		byte [] StringToByte (string str)
		{
			byte [] b = new byte [str.Length];
			for (int x = 0; x < str.Length; ++x)
				b[x] = (byte) str[x];
			return (b);
		}

		void OnPrintPage(object sender, PrintPageEventArgs e)
		{
// Create your own printer font in mnuFilePrint_Click()
// or use the one in textBox1
			Font fontPrint = textBox1.Font;
			float linesPerPage = 0;
			float yPos = 0;
			int count = 0;
			float leftMargin = e.MarginBounds.Left;
			float topMargin = e.MarginBounds.Top;
			string line = null;
// Declare some layout objects.
// A SizeF structure to hold the size of the line
			SizeF size = new SizeF();
// StringFormat to tell the MeasureString() method that
// we want the line to break on a character
			StringFormat sf = new StringFormat ();
			sf.Trimming = StringTrimming.Character;
			SizeF layout = new SizeF (-1, fontPrint.GetHeight ());

// Calculate the number of lines per page.
			linesPerPage = e.MarginBounds.Height / 
				fontPrint.GetHeight(e.Graphics);
// Print each line of the file.
			while(count < linesPerPage)
			{
// Pick up any residual text from the previous page/line
// that wouldn't fit on a line
				if (m_strRemaining.Length != 0)
				{
					line = m_strRemaining;
					m_strRemaining = "";
				}
// if no residual text, get a new line.
				else
				{
					if ((line = m_PrintReader.ReadLine()) == null) 
						break;
					ExpandTabs (ref line);
				}
// Calculate the y position on the page
				yPos = topMargin + (count * 
					fontPrint.GetHeight(e.Graphics));
// Save the line in a temporary variable
				string first = line;
// Measure the string in the selected font
				size = e.Graphics.MeasureString (first, fontPrint, layout, sf);
				int index = first.Length - 1;
				if (size.Width > e.MarginBounds.Width)
				{
// If there is no space in the line, break on a character
					if (first.LastIndexOf (" ", first.Length - 1) < 0)
					{
						while (size.Width > e.MarginBounds.Width)
						{
							first = line.Substring (0, --index);
							size = e.Graphics.MeasureString (first, fontPrint, layout, sf);
						}
					}
					else
// Step back through the line word by word until it fits
					{
						while (size.Width > e.MarginBounds.Width)
						{
							index = first.LastIndexOf (" ", first.Length - 1);
							first = line.Substring (0, index);
							size = e.Graphics.MeasureString (first, fontPrint, layout, sf);
						}
						++index;
					}
// Save any remaining text
					m_strRemaining = line.Substring (index);
				}
// Draw the text on the page
				e.Graphics.DrawString(first, fontPrint, Brushes.Black, 
					leftMargin, yPos, new StringFormat());
				count++;
			}
// Continue to the next page if the last line was not null.
// Note: the PrintDocument.Print() method will issue a form feed
// each time you return from this method with e.HasMorePages
// set to true.
			if(line != null)
				e.HasMorePages = true;
// Otherwise it is the end of the file as we know it.
// Note: returning with e.HasMorePages set to false will
// end the print job and send it to the spooler.
			else
				e.HasMorePages = false;
		}
		// Expand the tabs to eight spaces. This is the setting for
		// the text box control.
		private void ExpandTabs (ref string text)
		{
			string str = text;
			int index = str.IndexOf ('\t');
			if (index < 0)
				return;
			StringBuilder untabbed = new StringBuilder (str);
			do
			{
				int spaces = 8 - index % 8;
				untabbed.Remove (index, 1);
				untabbed.Insert (index, " ", spaces);
				str = untabbed.ToString();
				index = untabbed.ToString().IndexOf ('\t');
			} while (index > 0);
			text = str;
		}
	}
}
