namespace nsClassLib
{
    using System;
    using System.IO;
    using System.Windows.Forms;
    class clsMain
    {
        static public void Main ()
        {
            OpenFileDialog ofn = new OpenFileDialog ();
            ofn.Filter = "C Sharp Files (*.cs)|*.cs|Text Files (*.txt)|*.txt";
            ofn.Title = "Type File";
            while (true)
            {
                if (ofn.ShowDialog () == DialogResult.Cancel)
                    return;
                FileStream strm;
                try
                {
                    strm = new FileStream (ofn.FileName, FileMode.Open, FileAccess.Read);
                    StreamReader rdr = new StreamReader (strm);
                    while (rdr.Peek() >= 0)
                    {
                         string str = rdr.ReadLine ();
                         Console.WriteLine (str);
                    }
                }
                catch (Exception)
                {
                    MessageBox.Show ("Error opening file", "File Error",
                                     MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                ofn.Title = "Next File to Type";
            }
        }
    }
}
