// CondMeth.cs -- demonstrates the use of a conditional method
//
//                Compile this program with the following command line:
//                    C:>csc CondMeth.cs
//
#define MY_CONDITION

using System;
using System.Diagnostics;

namespace nsConditional
{
    class clsMain
    {
        static public void Main ()
        {
            clsTest test = new clsTest(42);
            test.ShowValue ();
        }
    }
    class clsTest
    {
        public clsTest (int num)
        {
            m_Num = num;
        }
        int m_Num;

        [Conditional("MY_CONDITION")]
        public void ShowValue()
        {
            if (m_Num < 50)
            {
                Console.WriteLine (m_Num + " is less than 50");
            }
        }
    }
}
