// EnvExit.cs -- Demonstrates the use of Environment.Exit() in
//               a command line program.
//
//               Compile this program with the following command line:
//                   C:>csc EnvExit.cs
namespace nsEnvExit
{
    using System;
    class clsMain
    {
        static public void Main ()
        {
            FirstFunction ();
            Console.WriteLine ("Application ends");
        }
        static public void FirstFunction()
        {
            SecondFunction ();
            Console.WriteLine ("First Function ends");
        }
        static public void SecondFunction()
        {
            ThirdFunction ();
            Console.WriteLine ("First Function ends");
        }
        static public void ThirdFunction()
        {
            try
            {
                Exception e = new Exception ();
                throw (e);
            }
            catch (Exception)
            {
                Console.WriteLine ("No other lines should print " +
                                   "to the console");
                Environment.Exit (-1);
            }
        }
    }
}
