using System;
using System.Collections;
using System.Windows.Forms;

namespace List
{
	/// <summary>
	/// 
	/// </summary>
	public class clsSort : System.Collections.IComparer
	{
//		public clsSort()
//		{
//			// 
//			// TODO: Add constructor logic here
//			//
//		}
//
// Compare() is a required method when using the ICompare interface
		public int Compare (object o1, object o2)
		{
			if (!(o1 is ListViewItem))
				return (0);
			if (!(o2 is ListViewItem))
				return (0);
//
// Get the listview items and extract the subitem text
// using the value saved in the ByColumn property.
			ListViewItem lvi1 = (ListViewItem) o2;
			string str1 = lvi1.SubItems[ByColumn].Text;
			ListViewItem lvi2 = (ListViewItem) o1;
			string str2 = lvi2.SubItems[ByColumn].Text;
//
// Compare the strings according to the sort order property
// and save the result.
			int result;
			if (lvi1.ListView.Sorting == SortOrder.Ascending)
				result = String.Compare (str1, str2);
			else
				result = String.Compare (str2, str1);
//
// Saving the sort information lets us do a reverse sort
// on the column if it is clicked a second time.
			LastSort = ByColumn;
// Return the result to the ListView.
			return (result);
		}

		/// <summary>
		/// Column number to sort by
		/// </summary>
		public int ByColumn
		{
			get {return Column;}
			set {Column = value;}
		}
		int Column = 0;
//
// Set and get the column used in the last sort.
		public int LastSort
		{
			get {return LastColumn;}
			set {LastColumn = value;}
		}
		int LastColumn = 0;
	}
}
