//
//  Members.cs -- Demonstrates access to static and non-static members
//
//                Compile this program using the following command line:
//                    C:>csc Members.cs
//
namespace nsMembers
{
    using System;
    class clsMain
    {
        static public void Main ()
        {
//
// Access a static member using the class name. You may access a static
// member without creating an instance of the class
            Console.WriteLine ("The static member is pi: " + clsClass.pi);
//
// To access a non-static member, you must create an instance of the class
            clsClass instance = new clsClass();
//
// Access a static member using the name of the variable containing the
// instance reference
            Console.WriteLine ("The instance member is e: " + instance.e);
        }
    }
    class clsClass
    {
//
// Declare a static field. You also could use the const keyword instead of static
        static public double pi = 3.14159;
//
// Declare a normal member, which will be created when you declare an instance
// of the class
        public double e = 2.71828;
    }
}
