// Geom.cs -- Demonstrates using an assembly.
//
//            Build this program and the Circle assembly using
//            the following command sequence:
//                C:>csc /t:module Circle.cs
//                C:>sn k Circle.snk
//                C:>al /keyfile:Circle.snk /version:1.0.0.0 /out:Circle.dll Circle.NetModule
//                C:>gacutil /i Circle.dll
//                C:>csc /r:circle.dll Geom.cs
//
using System;
using nsCircle;

namespace nsGeometry
{
    class clsMain
    {
        static public void Main ()
        {
            double angle = 32.6;
// Create an instance of the circle class.
            clsCircle circle = new clsCircle (420, 0, 0);
// Get the point on the circle at the angle.
            POINT pt = circle.PointOnCircle (angle);
// Show the total area of the circle.
            Console.WriteLine ("The area of the circle is " + circle.Area);
// Show the point.
            Console.WriteLine ("The point on the circle is at " + pt);
// Show the area of the slice between 0 degrees and the angle.
            Console.WriteLine ("The area of the slice is " +
                                circle.AreaOfSlice (angle));
        }
    }
}
