//
//  Sizes.cs -- returns the sixes of C# data types.
//              Compile with the following command line:
//                  csc /unsafe sizes.cs
//
namespace nsSizes
{
    using System;
    struct TestStruct
    {
        int    x;
        double y;
        char   ch;
    }

    class clsMain
    {
        static public unsafe void Main ()
        {
            Console.WriteLine ("The size of a bool is " + sizeof (bool));
            Console.WriteLine ("The size of a char is " + sizeof (char));
            Console.WriteLine ("The size of an int is " + sizeof (int));
            Console.WriteLine ("The size of a long is " + sizeof (long));
            Console.WriteLine ("The size of an double is " + sizeof (double));
            Console.WriteLine ("The size TestStruct is " + sizeof (TestStruct));
        }
    }
}
